truffe2/app/urls.py
from django.conf.urls import patterns, include, url
from django.conf import settings

urlpatterns = patterns('',
    url(r'', include('main.urls')),
    url(r'^accounting/core/', include('accounting_core.urls')),
    url(r'^accounting/tools/', include('accounting_tools.urls')),
    url(r'^accounting/main/', include('accounting_main.urls')),
    url(r'^users/', include('users.urls')),
    url(r'^members/', include('members.urls')),
    url(r'^units/', include('units.urls')),
    url(r'^communication/', include('communication.urls')),
    url(r'^notifications/', include('notifications.urls')),
    url(r'^logistics/', include('logistics.urls')),
    url(r'^vehicles/', include('vehicles.urls')),
    url(r'^generic/', include('generic.urls')),

    url(r'^impersonate/', include('impersonate.urls')),

    (r'^' + settings.MEDIA_URL[1:] + '(?P<path>.*)$', 'django.views.static.serve', {'document_root': settings.MEDIA_ROOT}),  # In prod, use apache !
    (r'^' + settings.STATIC_URL[1:] + '(?P<path>.*)$', 'django.views.static.serve', {'document_root': settings.STATIC_ROOT}),  # In prod, use apache !
)

truffe2/members/urls.py
# -*- coding: utf-8 -*-

from django.conf.urls import patterns, url


urlpatterns = patterns(
    'members.views',

    url(r'^memberset/(?P<pk>[0-9]+)/export$', 'export_members'),
    url(r'^memberset/(?P<pk>[0-9]+)/import$', 'import_members'),
    url(r'^memberset/(?P<pk>[0-9]+)/import_list$', 'import_members_list'),
    url(r'^memberset/(?P<pk>[0-9]+)/json$', 'membership_list_json'),
    url(r'^memberset/(?P<pk>[0-9]+)/add$', 'membership_add'),

    url(r'^memberset/(?P<pk>[0-9]+)/api/v1/info$', 'memberset_info_api'),
    url(r'^memberset/(?P<pk>[0-9]+)/api/v1/$', 'memberset_api'),

    url(r'^membership/(?P<pk>[0-9]+)/delete$', 'membership_delete'),
    url(r'^membership/(?P<pk>[0-9~]+)/toggle_fees$', 'membership_toggle_fees'),

)

truffe2/members/models.py
# -*- coding: utf-8 -*-

from django import forms
from django.db import models
from django.conf import settings
from django.utils.translation import ugettext_lazy as _

from app.utils import get_current_unit
from generic.models import GenericModel, GenericStateModel, GenericGroupsModel, FalseFK, SearchableModel
from rights.utils import UnitEditableModel


class _MemberSet(GenericModel, GenericStateModel, GenericGroupsModel, UnitEditableModel, SearchableModel):

    class MetaRightsUnit(UnitEditableModel.MetaRightsUnit):
        access = ['INFORMATIQUE', 'PRESIDENCE']
        world_ro_access = True

    name = models.CharField(_('Nom'), max_length=255)
    unit = FalseFK('units.models.Unit', verbose_name=_(u'Unité'))
    generates_accred = models.BooleanField(_(u'Génère des accreds'), default=True)
    generated_accred_type = FalseFK('units.models.Role', blank=True, null=True, verbose_name=_(u'Accréditation générée pour les membres'))
    ldap_visible = models.BooleanField(_(u'Rend les accreds visibles dans l\'annuaire'), default=False)
    handle_fees = models.BooleanField(_(u'Gestion des cotisations'), default=False)

    api_secret_key = models.CharField(_(u'Clé secrète pour l\'API'), max_length=128, blank=True, null=True)

    class MetaData:
        list_display = [
            ('name', _('Nom du groupe de membres')),
            ('generates_accred', _(u'Génère une accréditation')),
            ('ldap_visible', _(u'Visible dans l\'annuaire EPFL')),
            ('handle_fees', _(u'Gestion des cotisations')),
            ('status', _('Statut')),
        ]
        details_display = list_display
        details_display.insert(2, ('generated_accred_type', _(u'Type généré')))

        default_sort = "[1, 'asc']"  # name

        filter_fields = ('name', 'status')

        base_title = _('Groupes de Membres')
        list_title = _('Liste des groupes de membre')
        base_icon = 'fa fa-list'
        elem_icon = 'fa fa-male'

        menu_id = 'menu-members-memberset'

        yes_or_no_fields = ['generates_accred', 'ldap_visible', 'handle_fees']

        has_unit = True

        help_list = _(u"""Les groupes de membres représentent l'ensemble des membres des différentes unités de l'AGEPoly.
Par exemple, ils peuvent contenir les membres d'honneurs d'une unité ou les membres qui cotisent.
Les groupes peuvent générer une accréditation EPFL pour leurs membres et gérer les cotisations suivant leur état.""")

    class MetaState:

        states = {
            '0_preparing': _(u'En préparation'),
            '1_active': _(u'Actif'),
            '2_archived': _(u'Archivé'),
        }

        default = '0_preparing'

        states_texts = {
            '0_preparing': _(u'Le groupe de membres est en cours de création et n\'est pas public.'),
            '1_active': _(u'Le groupe de membres est actif.'),
            '2_archived': _(u'Le groupe de membres est archivé.'),
        }

        states_links = {
            '0_preparing': ['1_active'],
            '1_active': ['2_archived'],
            '2_archived': [],
        }

        states_colors = {
            '0_preparing': 'primary',
            '1_active': 'success',
            '2_archived': 'default',
        }

        states_icons = {
            '0_preparing': '',
            '1_active': '',
            '2_archived': '',
        }

        list_quick_switch = {
            '0_preparing': [('1_active', 'fa fa-check', _(u'Rendre le groupe de membres actif')), ],
            '1_active': [('2_archived', 'fa fa-check', _(u'Archiver le groupe de membres')), ],
            '2_archived': [],
        }

        forced_pos = {
            '0_preparing': (0.1, 0.5),
            '1_active': (0.5, 0.5),
            '2_archived': (0.9, 0.5),
        }

        states_default_filter = '0_preparing,1_active'
        states_default_filter_related = '1_active,2_archived'
        status_col_id = 3

    class MetaSearch(SearchableModel.MetaSearch):

        extra_text = u'set staff anciens'

        fields = [
            'name',
        ]

    class MetaEdit:
        only_if = {
            'api_secret_key': lambda (x, user): user.is_superuser
        }

    def genericFormExtraClean(self, data, form):
        """Check if accred corresponds to generation constraints & that unique_together is fulfiled"""
        from members.models import MemberSet

        if 'generates_accred' in form.fields:
            if data['generates_accred'] and data['generated_accred_type'] is None:
                raise forms.ValidationError(_(u'Accréditation nécessaire pour l\'attribuer aux membres.'))

            if 'generates_accred' not in data:  # If no accred generation, both other fields are Blank/False
                data['generated_accred_type'] = ''
                if 'ldap_visible' in data:
                    del data['ldap_visible']

        if MemberSet.objects.exclude(pk=self.pk).filter(unit=get_current_unit(form.truffe_request), name=data['name']).count():
            raise forms.ValidationError(_(u'L\'unité possède déjà un groupe avec ce nom.'))  # Potentiellement parmi les supprimées

    def genericFormExtraInit(self, form, current_user, *args, **kwargs):
        """Reduce the list of possible accreds to the official ones at EPFL"""
        from units.models import Role

        form.fields['generated_accred_type'].queryset = Role.objects.exclude(id_epfl='')

    def may_switch_to(self, user, dest_state):

        return self.rights_can('EDIT', user)

    def can_switch_to(self, user, dest_state):

        if self.status == '2_archived' and not user.is_superuser:
            return (False, _(u'Seul un super utilisateur peut sortir cet élément de l\'état archivé'))

        if int(dest_state[0]) - int(self.status[0]) != 1 and not user.is_superuser:
            return (False, _(u'Seul un super utilisateur peut sauter des étapes ou revenir en arrière.'))

        if not self.rights_can('EDIT', user):
            return (False, _('Pas les droits.'))

        return super(_MemberSet, self).can_switch_to(user, dest_state)

    class Meta:
        abstract = True
        unique_together = ("name", "unit")

    def __unicode__(self):
        return u"{} ({})".format(self.name, self.unit)

    def rights_can_EDIT(self, user):
        # On ne peut pas éditer/supprimer les groupes archivés.

        if self.status == '2_archived':
            return False
        return super(_MemberSet, self).rights_can_EDIT(user)


class Membership(models.Model):
    user = models.ForeignKey(settings.AUTH_USER_MODEL)
    group = models.ForeignKey('MemberSet', verbose_name=_('Groupe de membres'))
    start_date = models.DateTimeField(_('Date d\'ajout au groupe'), auto_now_add=True)
    end_date = models.DateTimeField(_('Date de retrait du groupe'), blank=True, null=True)
    payed_fees = models.BooleanField(_(u'A payé sa cotisation'), default=False)

    def payed_due_fees(self):
        """Return the status of fees if MemberSet handle fees."""
        if self.group.handle_fees:
            return self.payed_fees
        return None

truffe2/members/templates/members/memberset/edit.html
{% extends "generic/generic/edit.html" %}
{% load i18n %}

{% block edit_bonus %}
    <script type="text/javascript">

        // Move generated_accred_type up
        var generated_accred_type = $('#id_generated_accred_type').parents('.form-group').remove();
        $('#id_generates_accred').parents('.form-group').after(generated_accred_type);

        $(function() {
            // Transform id_generated_accred_type in select2
            $('#id_generated_accred_type').removeClass('form-control');
            $('#id_generated_accred_type').width('72%').select2();

            // Manage visibility in accred block
            $('#id_generates_accred').click(function() {
                var new_state = $('#id_generates_accred').prop('checked');
                if (!new_state) {
                    $('#id_ldap_visible').prop('checked', false);
                }
                $('#id_ldap_visible').attr('disabled', !new_state);
                $('#id_generated_accred_type').attr('disabled', !new_state);
                if($('#id_generated_accred_type').attr('disabled')) {
                    $('#id_generated_accred_type').val('');
                    $('#s2id_id_generated_accred_type .select2-chosen').text('---------');
                }

            });

            // Manage initial visibility of accred block
            if(!$('#id_generates_accred').prop('checked')) {
                $('#id_ldap_visible').attr('disabled', true);
                $('#id_generated_accred_type').attr('disabled', true);
            }
        });
    </script>
{% endblock %}

truffe2/members/templates/members/memberset/info_api.html
{% load i18n bootstrap3 %}


<form id="info-api-form" method="POST" action="{% url 'members.views.memberset_info_api' obj.pk %}" enctype="multipart/form-data">
    {% csrf_token %}

    <div class="modal-content">

        <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-hidden="true">
                &times;
            </button>
            <h4 class="modal-title" id="myModalLabel">{% trans "Informations sur l'API" %}</h4>
        </div>

        <div class="modal-body">

            <h3>{% trans "URL de l'API" %}</h3>
            {% trans "L'URL de base de l'API est:" %}<br />
            <pre>{{website_path}}{% url 'members.views.memberset_api' obj.pk %}</pre>
            {% trans "Cette url est unique par groupe de membre." %}

            <h3>{% trans "Clé secrète" %}</h3>
            {% trans "La clé secrète de l'API est:" %}<br />
            <pre>{{obj.api_secret_key|default:"Pas de clé"}}</pre>
            {% trans "Cette clé est unique par groupe de membre. Tu peux la changer avec ce bouton: " %}
            <button type="submit" class="btn btn-danger btn-xs"><i class="fa fa-refresh"></i> {% trans "Générer une nouvelle clé" %}</button>

            <h3>{% trans "Usage de la clé" %}</h3>
            {% trans "Pour utiliser la clé, tu peux soit la passer dans l'url (non-recommandé) avec le paramètre key" %} (<pre style="display: inline; padding: 0;">https://[url]?key=[key]</pre>)
            {% trans "ou la transmettre via le header HTTP X-Truffe2-Key" %} (<pre style="display: inline; padding: 0;">X-Truffe2-Key: [key]</pre>)

            <h3>{% trans "Methode GET" %} <i class="fa fa-list"></i></h3>
            {% trans "En faisant une requête GET sur l'URL, tu recevras une liste au format JSON avec le sciper des membres, ainsi que l'éventuel statut de la cotisation. Exemple:" %}
            <pre>curl -H "X-Truffe2-Key: {{obj.api_secret_key|default:"ta-clé"}}" {{website_path}}{% url 'members.views.memberset_api' obj.pk %}</pre>
<pre>{
    "members": [
        {
            "sciper": "179189",
            "payed_fees": false,
            "added_date": "2015-06-16 16:43:35+00:00"
        },
        {
            "sciper": "185952",
            "payed_fees": true,
            "added_date": "2016-05-29 15:31:45+00:00"
        }
    ]
}
            </pre>

            <h3>{% trans "Methode PUT" %} <i class="fa fa-plus"></i></h3>
            {% trans "En faisant une requête PUT sur l'URL, tu peux ajouter un membre et/ou définir le statut de sa cotisation. Retourne 3 résultats possibles: 'CREATED' si le membre a été crée, 'UPDATED_FEE' si la cotisation à été mise à jour ou 'ALREADY_OK' si rien n'a changé. Par défault, si rien n'est spécifié, les cotisations sont misent à False. Exemple:" %}
            <pre>curl -X PUT -d '{ "member": { "sciper": "110855", "payed_fees": false } }' -H "X-Truffe2-Key: {{obj.api_secret_key|default:"ta-clé"}}" {{website_path}}{% url 'members.views.memberset_api' obj.pk %}</pre>
<pre>{"result": "CREATED"}</pre>


            <br />
            <pre>curl -X PUT -d '{ "member": { "sciper": "110855", "payed_fees": false } }' -H "X-Truffe2-Key: {{obj.api_secret_key|default:"ta-clé"}}" {{website_path}}{% url 'members.views.memberset_api' obj.pk %}</pre>
<pre>{"result": "ALREADY_OK"}</pre>


            <br />
            <pre>curl -X PUT -d '{ "member": { "sciper": "110855", "payed_fees": true } }' -H "X-Truffe2-Key: {{obj.api_secret_key|default:"ta-clé"}}" {{website_path}}{% url 'members.views.memberset_api' obj.pk %}</pre>
<pre>{"result": "UPDATED_FEE"}</pre>

            <br />
            {% trans "Le système peut aussi te retourner une erreur. Par exemple si le sciper n'est pas dans le LDAP de l'EPFL, 'WRONG_SCIPER' sera retourné. Si tu oublies de passer des informations, 'MISSING_MEMBER' ou 'MISSING_SCIPER' sera retourné." %}
            <pre>curl -X PUT -d '{ "member": { "sciper": "Patrick", "payed_fees": false } }' -H "X-Truffe2-Key: {{obj.api_secret_key|default:"ta-clé"}}" {{website_path}}{% url 'members.views.memberset_api' obj.pk %}</pre>
<pre>{"error": "WRONG_SCIPER"}</pre>

            <h3>{% trans "Methode DELETE" %} <i class="fa fa-times"></i></h3>
            {% trans "En faisant une requête DELETE sur l'URL, tu peux supprimer un membre. Retourne 2 résultats possibles: 'REMOVED' si le membre a été retiré et 'ALREADY_OK' si l'utilisateur n'était pas un membre.  Exemple:" %}
            <pre>curl -X DELETE -d '{ "member": { "sciper": "110855" } }' -H "X-Truffe2-Key: {{obj.api_secret_key|default:"ta-clé"}}" {{website_path}}{% url 'members.views.memberset_api' obj.pk %}</pre>
<pre>{"result": "REMOVED"}</pre>


            <br />
            <pre>curl -X DELETE -d '{ "member": { "sciper": "110855" } }' -H "X-Truffe2-Key: {{obj.api_secret_key|default:"ta-clé"}}" {{website_path}}{% url 'members.views.memberset_api' obj.pk %}</pre>
<pre>{"result": "ALREADY_OK"}</pre>

            <br />
            {% trans "Le système peut aussi te retourner une erreur. Par exemple, si tu oublies de passer des informations, 'MISSING_MEMBER' ou 'MISSING_SCIPER' sera retourné. Si aucun utilisateur n'existe dans le LDAP avec le sciper envoyé, 'UNKNOWN_USER' sera retourné." %}
            <pre>curl -X DELETE -d '{ "member": { } }' -H "X-Truffe2-Key: {{obj.api_secret_key|default:"ta-clé"}}" {{website_path}}{% url 'members.views.memberset_api' obj.pk %}</pre>
<pre>{"error": "MISSING_SCIPER"}</pre>


            <h3>{% trans "Methode POST" %} <i class="fa fa-save"></i></h3>
            {% trans "En faisant une requête POST sur l'URL, tu peux définir une liste de membres. Le système te retourne une liste des modifications appliquées via 5 listes: 'created', la liste des membres ajoutés, 'updated', la liste des membres dont la cotisation a été mise à jour, 'already_ok', la liste des membres sans modifications, 'removed', la liste des membres retirés et 'errors' avec la liste des erreurs.  Exemple:" %}
            <pre>curl -X POST -d '{ "members": [ { "sciper": "185952" }, { "sciper": "179189", "payed_fees": true }, { "sciper": "Partick" }, { "sciper": "104359" } ] }' -H "X-Truffe2-Key: {{obj.api_secret_key|default:"ta-clé"}}" {{website_path}}{% url 'members.views.memberset_api' obj.pk %}</pre>
<pre>{
    "created": ["104359"]
    "updated": ["179189"],
    "already_ok": ["185952"],
    "deleted": ["110855"],
    "errors": [
        {"sciper": "Partick", "error": "WRONG_SCIPER"}
    ],
}</pre>

            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">
                    {% trans "Fermer" %}
                </button>
            </div>
        </div>

    </div><!-- /.modal-content -->

  <script type="text/javascript">
        $('#info-api-form').ajaxForm({replaceTarget: true, target: '#info-api-form'});
  </script>
</form>

truffe2/members/templates/members/memberset/show.html
{% extends "generic/generic/show.html" %}
{% load i18n generic_extras rights_extras %}

{% block content %}
    <br/>
    <div role="widget" class="jarviswidget jarviswidget-sortable" id="wid-id-11" data-widget-colorbutton="false" data-widget-editbutton="false" data-widget-togglebutton="false" data-widget-deletebutton="false" data-widget-fullscreenbutton="false" data-widget-custombutton="false">
        <header role="heading">
            <h2>{{obj}}</h2>

            <ul id="widget-tab-memberset" class="nav pull-right nav-tabs">
                <li class="">
                    <a data-toggle="tab" href="#hr1"> <i class="fa fa-lg fa-list"></i> <span class="hidden-mobile hidden-tablet">{% trans "Liste" %}</span> </a>
                </li>
                <li class="active">
                    <a data-toggle="tab" href="#hr2"> <i class="fa fa-lg fa-gear"></i> <span class="hidden-mobile hidden-tablet">{% trans "Gestion" %}</span></a>
                </li>
            </ul>

            <span class="jarviswidget-loader"><i class="fa fa-refresh fa-spin"></i></span>
        </header>

        <!-- widget div-->
        <div role="content">

            <!-- widget edit box -->
            <div class="jarviswidget-editbox">
                <!-- This area used as dropdown edit box -->
            </div> <!-- end widget edit box -->

            <div class="widget-body no-padding"> <!-- widget content -->

                <div class="tab-content padding-10"> <!-- widget body text-->
                    <div class="tab-pane fade" id="hr1">
                        <section id="widget-grid" class="">
                            <div class="row">
                                <div class="col-sm-12 col-md-{% if Model.MetaData.help_list %}10{% else %}12{% endif %} col-lg-{% if Model.MetaData.help_list %}10{% else %}12{% endif %}">
                                    {% with w_title="Liste" w_nopadding=True w_no_toggle=True %}{% include "widget/header.html" %}{% endwith %}
                                    <div class="widget-body-toolbar"></div>
                                    <table id="main_list_table" class="table table-striped table-hover">
                                        <thead>
                                            <tr>
                                                <th>{% trans "Utilisateur" %}</th>
                                                <th>{% trans "Date d'ajout" %}</th>
                                                {% if obj.handle_fees %}<th>{% trans "Cotisation payée ?" %}</th>{% endif %}
                                                <th style="width: 200px;"></th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                        </tbody>
                                    </table>

                                    <div style="padding: 5px; display: none;" id="doable_block">
                                        <div class="pull-right" style="margin-right: 5px;">
                                          {% trans "Effectuer une action sur les <span id='doable_nb'></span> élément(s) sélectionné(s) :" %}

                                          <div id="doable_buttons" style="text-align: right;"></div>

                                        </div>

                                    </div>

                                    <hr style="clear: both; visibility: hidden;">

                                    {% include "widget/footer.html" %}

                                    <div style="float: right;">
                                        {% ifhasright obj user 'SHOW' %}
                                          <a href="{% url 'members.views.export_members' obj.pk %}" class="btn btn-default">
                                            <i class="fa fa-download"></i>
                                            {% trans "Exporter" %}
                                          </a>
                                        {% endifhasright %}

                                        {% ifhasright obj user 'EDIT' %}
                                          <a href="#hr1" onclick="disp_import();" data-remote="{% url 'members.views.import_members' obj.pk %}" base-data-remote="{% url 'members.views.import_members' obj.pk %}" id="import-membership-button" class="btn btn-default">
                                            <i class="fa fa-upload"></i>
                                            {% trans "Importer (fichier)" %}
                                          </a>

                                          <a href="#hr1" onclick="disp_import_list();" data-remote="{% url 'members.views.import_members_list' obj.pk %}" base-data-remote="{% url 'members.views.import_members_list' obj.pk %}" id="import-list-membership-button" class="btn btn-default">
                                            <i class="fa fa-upload"></i>
                                            {% trans "Importer (Liste)" %}
                                          </a>

                                          <a href="#hr1" onclick="disp_add();" data-remote="{% url 'members.views.membership_add' obj.pk %}" base-data-remote="{% url 'members.views.membership_add' obj.pk %}" id="add-membership-button" class="btn btn-primary">
                                            <i class="fa fa-plus"></i>
                                            {% trans "Ajouter" %}
                                          </a>
                                        {% endifhasright %}
                                    </div>
                                </div>

                                {% if Model.MetaData.help_list %}
                                    <div class="col-sm-12 col-md-2 col-lg-2">
                                        {% if Model.MetaData.help_list %}
                                            {% with w_title="Aide" w_no_toggle=True %}{% include "widget/header.html" %}{% endwith %}
                                                {{Model.MetaData.help_list|linebreaksbr}}
                                            {% include "widget/footer.html" %}
                                        {% endif %}
                                    </div>
                                {% endif %}
                            </div>
                        </section>
                        {% url 'members.views.membership_list_json' obj.pk as json_url_memberset %}
                        {% with id="main_list_table" json_url_manual=json_url_memberset %}{% include "datatables.html" %}{% endwith %}

                    </div>
                    <div class="tab-pane fade active in" id="hr2">
                        {{block.super}}
                        <div style="padding-bottom: 40px;"></div> <!-- padding for buttons -->
                    </div>
                </div> <!-- end widget body text-->
            </div> <!-- end widget content -->
        </div> <!-- end widget div -->
    </div>

    <br /><br />

    <div class="modal fade" id="modal-add-membership" role="dialog" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
            </div>
        </div>
    </div>

    <div class="modal fade" id="modal-import-membership" role="dialog" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
            </div>
        </div>
    </div>
{% endblock %}

{% block bonus_block_infos %}

    {% ifhasright obj user 'EDIT' %}

        <h3  style="margin-bottom: 0px;">{% trans "API pour la gestion d'un groupe de membres" %}</h3>
        <small>{% trans "Il est possible de gérer avec une API un groupe de membres, pour automatiser certains processus." %}</small>

        <a href="#hr2" onclick="disp_api();" data-remote="{% url 'members.views.memberset_info_api' obj.pk %}" base-data-remote="{% url 'members.views.memberset_info_api' obj.pk %}" id="info-api-button" class="btn btn-default">
            <i class="fa fa-info"></i>
            {% trans "Informations sur l'API" %}
        </a>

        <div class="modal fade" id="modal-display-api-info" role="dialog" aria-hidden="true">
            <div class="modal-dialog" style="width: 900px;">
                <div class="modal-content">
                </div>
            </div>
        </div>
    {% endifhasright %}

{% endblock %}

{% block bonus_box %}
    <script type="text/javascript">

        var csrftoken;

        $(function() {
            // Remove title in super SHOW from generic
            $('#hr2 h1').remove();
            $('#hr2 hr').remove();

            // Activate list panel after load if requested to display this one.
            if(window.location.hash == '#hr1')
                $('#widget-tab-memberset li:first a').click();

            csrftoken = getCookie('csrftoken');

            $.ajaxSetup({
                beforeSend: function(xhr, settings) {xhr.setRequestHeader("X-CSRFToken", csrftoken);}
            });

            // Remove additional headers
            var fix_headers = setInterval(function(){ remove_headers(); }, 1000);

            function remove_headers() {
                var elem_removed = $('.FixedHeader_Cloned.dataTables_wrapper.fixedHeader.FixedHeader_Header').remove();
                if (elem_removed.length > 0) {
                    clearInterval(fix_headers);
                }
            }
        });

        // Get CSRF Cookie
        function getCookie(name) {
            var cookieValue = null;
            if (document.cookie && document.cookie !== '') {
                var cookies = document.cookie.split(';');
                for (var i = 0; i < cookies.length; i++) {
                    var cookie = jQuery.trim(cookies[i]);
                    if (cookie.substring(0, name.length + 1) == (name + '=')) {
                        cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                        break;
                    }
                }
            }
            return cookieValue;
        }

        function disp_add() {
            //Allow usage of select2
            $.fn.modal.Constructor.prototype.enforceFocus = function () {};
            $('#modal-add-membership').find('.modal-content').html('');
            $('#modal-add-membership').removeData('bs.modal');
            $('#modal-add-membership').modal({remote: $('#add-membership-button').attr('data-remote')});
        }

        function disp_import() {
            //Allow usage of select2
            $.fn.modal.Constructor.prototype.enforceFocus = function () {};
            $('#modal-import-membership').find('.modal-content').html('');
            $('#modal-import-membership').removeData('bs.modal');
            $('#modal-import-membership').modal({remote: $('#import-membership-button').attr('data-remote')});
        }

        function disp_import_list() {
            //Allow usage of select2
            $.fn.modal.Constructor.prototype.enforceFocus = function () {};
            $('#modal-import-membership').find('.modal-content').html('');
            $('#modal-import-membership').removeData('bs.modal');
            $('#modal-import-membership').modal({remote: $('#import-list-membership-button').attr('data-remote')});
        }

        function disp_api() {
            //Allow usage of select2
            $.fn.modal.Constructor.prototype.enforceFocus = function () {};
            $('#modal-display-api-info').find('.modal-content').html('');
            $('#modal-display-api-info').removeData('bs.modal');
            $('#modal-display-api-info').modal({remote: $('#info-api-button').attr('data-remote')});
        }

        function toggle_fees(mship_id) {
            $.post("{% url "members.views.membership_toggle_fees" 99942999 %}".replace(99942999, mship_id), function(){
                data_table_main_list_table._fnAjaxUpdate();
            });
        }
    </script>
{% endblock %}